#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "../../rhmusicfuncs/rhmusicfuncs.h"

#define Fourteen 14

char *rowlabel[] =
{
   "aih", "b",
   "c", "cis", "d", "dis",
   "e", "eih/f", "fih", "fis",
   "g", "gis", "aeh", "a", "aih",
   "safetydummy"
};

static void doit (int ratios)
{
   int row, col;

   printf("<html>\n");
   printf("<table>\n");

   printf("<tr>\n");
   for (col = Fourteen; col <= Fourteen * 2; col++)
   {
      if (col == 16)
         printf("<td></td><td></td>");
      printf("<td>%s</td>\n", rowlabel[col % Fourteen]);
   }
   printf("<td></td><td></td>");
   printf("</tr>\n<tr>\n");
   for (col = Fourteen; col <= Fourteen * 2; col++)
   {
      if (col == 16)
         printf("<td></td><td></td>");
      printf("<td>%d</td>\n", (col % Fourteen) + Fourteen);
   }
   printf("<td></td><td></td>");
   printf("</tr>\n");

   for (row = Fourteen; row <= Fourteen * 3; row++)
   {
      int index = row % Fourteen;
      int rowabs = (row % Fourteen) + Fourteen;
      long tocalc = row < Fourteen * 2 ? rowabs : rowabs * 2;

      printf("<tr>\n");
      for (col = Fourteen; col <= Fourteen * 2; col++)
      {
         if (col == 16)
         {
            printf("<td>%s</td>", rowlabel[index]);
            printf("<td>%2d</td>\n", rowabs);
         }
         if (!ratios)
         {
            double cents = rats2cents(tocalc, col);
            printf("\t<td>%7.1f</td> ", cents <= 1200.0 ? cents : cents - 1200);
         }
         else
         {
            long thisgcd = gcd(tocalc, col);
            printf("\t<td>%ld:%ld</td> ", tocalc / thisgcd, col / thisgcd);
         }
      }
      printf("<td>%2d</td>\n", rowabs);
      printf("<td>%s</td>\n", rowlabel[index]);
      printf("</tr>\n");
   }
   printf("<tr>\n");
   for (col = Fourteen; col <= Fourteen * 2; col++)
   {
      if (col == 16)
         printf("<td></td><td></td>");
      printf("<td>%d</td>\n", (col % Fourteen) + Fourteen);
   }
   printf("<td></td><td></td>");
   printf("</tr>\n<tr>\n");
   for (col = Fourteen; col <= Fourteen * 2; col++)
   {
      if (col == 16)
         printf("<td></td><td></td>");
      printf("<td>%s</td>\n", rowlabel[col % Fourteen]);
   }
   printf("<td></td><td></td>");
   printf("</tr>\n");

   printf("</table>\n");
   printf("</html>\n");
}

int main (void)
{
   doit(0);
   doit(1);

   return 0;
}

